#ifndef MyIntervalFunc_h
#define MyIntervalFunc_h
#include "defo.h"

extern MyInterval sqrt2;
extern MyInterval sqrt3;
extern MyInterval piConst;

void initIntervalGlobals();
// initiates some constants for interval computations

bool testDataCorectness(MyDouble left, MyDouble right);
// tests if left end of the interval is less or equal than right end

bool emptyIntersection(const MyInterval &X, const MyInterval &Y);
// returns: True iff X \cap Y=\emptyset

bool myIntersection(MyInterval X, MyInterval Y, MyInterval &result);
// returns: True iff X \cap Y \neq \empty; in such case on output result=X \cap Y
//          otherwise result is not changed

bool subSetInterior(const MyInterval &X, const MyInterval &Y);
// returns X \subset Interior of Y

bool subSet(const MyInterval &X, const MyInterval &Y);
// returns X \subset  Y

bool isomorphismTest(const MyMatrix &DFF);
// if returns true then DFF is isomorphism
//  when false - then DFF did not pass our test for being the isomorphism

MyInterval maxDiamOfMatrix(MyMatrix &M, int size, int &max_i, int &max_j);
// comutes maximal diameter of entries of matrix M[size][size]
#endif
