#ifndef testandhelp_h
#define testandhelp_h

#include "defo.h"

#include "bodies.h"

bool distanceTest(const Bodies &bodies);
// returns TRUE if:
//    when some constraints on mutual possition of the bodies are satisfied
//
// q_{n-2} is the body furthest from the origin
// and x_{n-2} > 0, y_{n-2} = 0,z_{n-2}

// IN THE PLANAR CASE
// y0 >= 0
//  additionaly in the case of equalMasses or !fixedOrderOfBodies
//    x0 <= xi for all xi  i.e. q0 the most left body
//    y1 <= yi for all yi (if N > 3) i.e. y1 the smallest y in the bodies
// IN THE SPATIAL CASE
//  // q_0 is the body furthest from the OX line
// y0 >= 0
// q_1 is the body furthest from the OXY plane
// z1 >= 0

/////  FOR THE REMAINING BODIES in the case of equalMasses
//  for the remaining bodies:
//    if (orderIncreasing)  x2 <= x3 <= ... <= x_{n-3} <= x_{n-1}
//     else   x2 >= ... >= x_{n-3} >= x_{n-1}

MyInterval aprioriEstimate(int N);
// returns the upper bound for CC with N-bodies

bool detCondForReducedSys(const Bodies &bodies, MyInterval &det);
/** returns TRUE if determinant of the matix A:
 *  (y_0 - y_{n-1})   (y_{n-2} - y_{n-1})
 * -(x_0 - x_{n-1})  -(x_{n-2} - x_{n-1})
 * is not singular, i.e. 0\not\in det A
*/
// this in 3D is needed to claim that the solution of the reduced system is in fact a central configuration

bool possibleSolution(Bodies &bodies);
//  Input values:
//     bodies - here we try to exclude CC
// returns: true if are tests rule out the existence of CC in <bodies>
//          false otherwise
//         some of the test update (shrink) bodies, so that all possible CC in bodies(on output) are contained
//         in bodies (the output value)

void setAprioriBoundsData(Bodies &bodies);
//  set general appriori bounds, both for equal and non-equal masses case
//  the function should be in agreement with <distanceTest>

#endif

MyInterval fixDirection(Bodies &bodies, MyMatrix &DFF, int size, int &varMax, int &coord);

MyDouble midPointInt(MyInterval interval);
